<template>
	<view>
		<view class="top">
			<view class="top-c ddflex">
				<view class="top-tab">
					<view class="filter ddflex" @click="showSearch">{{searchList[currentTab].label}}<image src="../../static/pages/images/bico.png" class="bico"></image></view>
					<view class="filter-list" v-if="isSearch">
						<view class="li" v-for="(item,index) in searchList" :key="index" @click="swiType(index)">{{item.label}}</view>
					</view>
				</view>
				<view class="search ddflex fflex">
					<image src="../../static/images/ssico.png"></image>
					<input v-model="searchText" :placeholder="'搜'+searchList[currentTab].label" placeholder-class="placeholder" @focus="focusSearch" @confirm="confirmSearch" class="ipt fflex" />
				</view>
			</view>
		</view>
		<view style="height: 90rpx;"></view>
		<block v-if="currentTab == 0 || currentTab == 1">
		<view class="cons-b">
			<view class="list" v-if="officeList && officeList.length > 0">
				<view class="li" v-for="(item, index) in officeList" :key="index">
					<view class="user ddflex" @click="jumpUrl('/topics/home/home?userId=' + item.userDTO.id)">
						<image :src="item.userDTO.avatar" mode="aspectFill" class="userimg"></image>
						<view class="fflex">
							<view class="namea ddflex">
								<view class="name fflex ddflex">{{ item.userDTO.nickName }}<image src="../../static/images/vip_tag.png" class="vip-tag" v-if="item.userDTO.levelGrade > 0"></image></view>
								<view class="time">{{ item.time }}</view>
							</view>
							<view class="area" v-if="item.userDTO.cityName">{{ item.userDTO.provinceName }} {{ item.userDTO.cityName }}</view>
						</view>
					</view>
					<view class="des" @click="jumpUrlDetail(item)"><rich-text :nodes="item.content"></rich-text></view>
					<!-- //如果有投票，就不显示图片 -->
					<block v-if="!item.qyPoll">
					<view class="video" v-if="item.isHaveVideo && config.open_community_video == 1">
						<video :src="item.url" :show-center-play-btn="false" :controls="item.isControls" :autoplay="item.isControls" :id="'myVideo'+index" @pause="videoPause(index)" @ended="videoEnded(index)"></video>
						<view class="video-play ddflex" @click="videoPlay(index)" v-if="item.isShowPlayBtn"><image src="../../static/images/play.png"></image></view>
					</view>
					<view class="imgbox ddflex" @click="jumpUrlDetail(item)" v-if="!item.isHaveVideo"><!-- @click="previewImgss(item.url, idx)" -->
						<block v-if="item.url&&item.url.length>0">
							<image mode="aspectFill" v-for="(it, idx) in item.url" :src="it" :key="idx"></image>
						</block>
					</view>
					</block>
					<!-- 话题 -->
					<view class="ddflex" v-if="item.qyDialogu">
						<view class="topic ddflex" @click="jumpUrl('/topics/detail/detail?topicId=' + item.qyDialogu.id)">
							<image src="../../static/images/topic.png"></image>
							{{ item.qyDialogu.title }}
						</view>
						<!-- <view class="topic ddflex" @click="jumpUrl('/topics/detail/detail?topicId=' + item.qyDialogu.id)">
							<image src="../../static/images/topic.png"></image>
							{{ item.qyDialogu.title }}
						</view> -->
					</view>
					<view class="loca ddflex" @click="jumpUrlPoi(item,'/office/poi/index')" v-if="item.poiName"><image :src="picUrlss+'office_images/loca.png'"></image><text v-if="item.poiDistance > 0">{{item.poiDistance ? item.poiDistance < 1000 ? item.poiDistance+'m' : (item.poiDistance/1000).toFixed(1)+'km' : ''}}</text>{{item.poiName}}</view>
					<!-- 投票 -->
					<view :class="'vote-box' + (item.qyPoll.isEnd ? ' ends' : '')" v-if="item.qyPoll">
						<view class="vote-tit">{{ item.qyPoll.title }}</view>
						<block v-if="item.qyPoll.isVote == 1">
							<view class="vote-list end" @click="jumpUrlDetail(item)">
								<view :class="'lis ddflex  ' + (itpy.isVote == 1 ? 'active' : '')" v-for="(itpy, idex) in JSON.parse(item.qyPoll.optionJson)" :key="idex">
									<view class="percent" :style="'width:' + parseFloat(itpy.proportion) + '%;'"></view>
									<view class="fflex">{{ itpy.name }}</view>
									<view>{{ parseFloat(itpy.proportion) + '%' }}</view>
								</view>
							</view>
						</block>
						<block v-else>
							<view class="vote-list">
								<view class="lis" v-for="(itpy, idex) in JSON.parse(item.qyPoll.optionJson)" :key="idex" @click="submitPoll(item, index, idex)">
									{{ itpy.name }}
								</view>
							</view>
						</block>
						<view class="vote-can" v-if="item.qyPoll.isEnd"><text>{{item.qyPoll.voteCount}}人参与</text>投票已结束</view>
					</view>
					<view class="product" v-if="item.products && item.products.length > 0">
						<view scroll-x="true" class="pro-view pro-view1" v-if="item.products.length == 1">
							<view class="lis" v-for="(it, idx) in item.products" :key="idx" @click="toProductDetail(it)">
								<view class="ddflex">
									<image :src="it.pic + '?x-oss-process=style/w375'" mode="aspectFill" class="pic"></image>
									<view class="fflex">
										<view class="title tover">{{ it.title }}</view>
										<view class="opts ddflex">
											<view class="money"><text>￥</text>{{ it.salePrice }}</view>
											<view class="pro-btn"><image src="../../static/pages/images/n_cart.png"></image></view>
										</view>
									</view>
								</view>
							</view>
						</view>
						<scroll-view scroll-x="true" class="pro-view" v-else>
							<view class="lis" v-for="(it, idx) in item.products" :key="idx" @click="toProductDetail(it)">
								<view class="ddflex">
									<image :src="it.pic + '?x-oss-process=style/w375'" mode="aspectFill" class="pic"></image>
									<view class="fflex">
										<view class="title tover">{{ it.title }}</view>
										<view class="opts ddflex">
											<view class="money"><text>￥</text>{{ it.salePrice }}</view>
											<view class="pro-btn"><image src="../../static/pages/images/n_cart.png"></image></view>
										</view>
									</view>
								</view>
							</view>
						</scroll-view>
					</view>
					<view class="opt ddflex" v-if="!item.source">
						<view class="fflex" @click="jumpUrlDetail(item)">{{fomatNumbers(item.count.browseCount)}}次浏览</view>
						<view class="ddflex" @click="submitFabulous(2, item.id, index)">
							<image :src="'../../static/images/' + (item.isPraise == 1 ? 'like_h' : 'like') + '.png'"></image>
							{{fomatNumbers(item.count.fabulousCount)}}
						</view>
						<view class="ddflex" @click="jumpUrlDetail(item)" v-if="config.is_show_create_btn == 1">
							<image src="../../static/images/comment.png"></image>
							{{fomatNumbers(item.count.commentCount)}}
						</view>
						<button open-type="share" hover-class="none" class="opt-share ddflex">
							<image src="../../static/images/share.png"></image>
							分享
						</button>
					</view>
				</view>
			</view>
			<view class="nodata" v-if="isNoData">
				<image :src="picUrlss + 'empty_jl.png'"></image>
				<text>未找到相关{{searchList[currentTab].label}}</text>
			</view>
		</view>
		</block>
		<block v-if="currentTab == 2">
		<view class="team-list">
			<view class="li ddflex" v-for="(item,index) in teamList" :key="index" @click="jumpUrl('/office/team/index?id='+item.id)">
				<image :src="item.url?item.url:picUrlss+'office_images/team_default.png'" mode="aspectFill" class="team-img"></image>
				<view class="fflex">
					<view class="team-tit tover">{{item.title}}</view>
					<view class="team-sta">
						<text>{{item.memberNum}}成员</text>
						<text>{{item.momentsNum}}帖子</text>
					</view>
				</view>
				<view class="join-btn" @click.stop="joinTeam(item,index)">{{item.isJoin == 1 ? '已加入':'加入'}}</view>
			</view>
		</view>
		<view class="nodata" v-if="isNoData">
			<image :src="picUrlss + 'empty_yq.png'"></image>
			<text>未找到团队</text>
		</view>
		</block>
	</view>
</template>

<script>
	const app = getApp();
	const api = require('../../utils/api.js');
	const req = require('../../utils/request.js');
	const util = require('../../utils/util.js');
	const QQMapWX = require("../../utils/qqmap.js");
	export default {
		components: {
		},
		data() {
			return {
				picUrlss: req.public.picUrls,
				currentTab: 0,
				isSearch: false,
				searchText: '',
				searchList: [
					{
						value: 1,
						label: '话题'
					},
					{
						value: 2,
						label: '投票'
					},
					{
						value: 3,
						label: '团队'
					}
				],
				isNoData: false,
				isShowPage: false,
				isLoad: true,
				form: {
					page: 1,
					limit: 10
				},
				pType: 1, //排序： 1综合, 2最新,3浏览最多,4评论最多,5热门
				officeList: [], //聊一聊
				videoCurrent: null,
				videoContext: '',
				teamForm: {
					page: 1,
					limit: 10
				},
				isTeamLoad: true,
				teamList: [],
				config: {},
				currentPoi: {},
			}
		},
		onLoad(options) {
			if(options.currentTab) this.currentTab = options.currentTab-1;
		},
		onShow() {
			this.config = JSON.parse(req.getStorage('configRes'))
		},
		onReachBottom() {
			if(this.currentTab > 1){
				this.teamForm.page++;
				this.getTeamPage();
			}else{
				this.form.page++;
				this.getOfficeList();
			}
		},
		methods: {
			showSearch(){
				this.isSearch = !this.isSearch;
			},
			swiType(index){
				if(this.currentTab == index){
					this.isSearch = false;
					return false;
				}
				this.currentTab = index;
				this.isSearch = false;
				this.officeList = [];
				this.teamList = [];
				this.isNoData = false;
				this.$forceUpdate();
				console.log(this.officeList,this.teamList)
			},
			focusSearch(){
				this.isSearch = false;
			},
			confirmSearch(){
				if(this.currentTab > 1){
					this.isTeamLoad = true;
					this.teamForm.page = 1;
					this.getTeamPage();
				}else{
					this.isLoad = true;
					this.form.page = 1;
					this.getOfficeList();
				}
			},
			//预览图片
			previewImgss(picUrls, index) {
				//预览合同图片
				var src = picUrls[index];
				let imgs = picUrls;
				uni.previewImage({
					current: src, // 当前显示图片的http链接
					urls: imgs
				});
			},
	
			removeHtml(content) {
				return util.removeHtml(content);
			},
			createJump(url) {
				if (!req.isLogins(true)) {
					return;
				}
				this.jumpUrl(url);
			},
			jumpUrl(url){
				uni.navigateTo({
					url: url
				})
			},
			jumpUrlPoi(item,url){
				this.currentPoi = item;
				uni.navigateTo({
					url: url
				})
			},
			jumpToPractice(item,url){
				let checkCategory = {
					id: item.question.cateId,
					name: item.question.cateName
				}
				req.setStorage('checkCategory',checkCategory)
				this.jumpUrl(url);
			},
			jumpUrlDetail(item) {
				this.jumpUrl('/office/detail/detail?contentId=' + item.id);
			},
			toProductDetail(item) {
				this.jumpUrl('/product/detail/detail?id=' + item.id);
			},
			sum(arr) {
				var s = 0;
				for (var i=arr.length-1; i>=0; i--) {
					if(arr[i].count){
						s += Number(arr[i].count);
					}
				}
				return s;
			},
			fomatNumbers(num){
				return util.formatNumbers(num)
			},
			getOfficeList() {
				let that = this;
				var pramData = {};
				pramData.page = this.form.page;
				pramData.limit = this.form.limit;
				// pramData.type = 4;
				if (this.pType == 5) {
					//热门
					pramData.isEssence = 2;
				} else {
					pramData.orderType = this.pType;
				}
				if(this.treeId) {
					pramData.treeId = this.treeId
					pramData.orderType = 1
				}else delete pramData.treeId
				pramData.searchType = this.currentTab+1;//1话题 2投票 3团队
				if(this.searchText) pramData.content = this.searchText;
				else delete pramData.content;
				if (!this.isLoad) return false;
				this.isLoad = false;
				req.getRequest('/api/v3/moments/page', pramData, data => {
					if(data.list&&data.list.length > 0){
						data.list.map(it=>{
							if(it.qyPoll && it.qyPoll.isEnd){
								it.qyPoll.voteCount = that.sum(JSON.parse(it.qyPoll.optionJson))
							}
							if(it.url){
								let h = it.url.substring(it.url.lastIndexOf('.') + 1)
								if(h.indexOf('mp4')<0&&h.indexOf('MP4')<0){
									it.url = it.url.split(',');
								}else{
									it.isHaveVideo = true
									it.isControls = false
									it.isShowPlayBtn = true
								}
							}
							it.content = '<div style="overflow: hidden;text-overflow: ellipsis;display: -webkit-box;-webkit-line-clamp: 5;-webkit-box-orient: vertical;word-break: break-all;">' + it.content + '</div>'
							return it;
						})
					}
					if (data.list && data.list.length >= 10) this.isLoad = true;
					if (this.form.page > 1) data.list = this.officeList.concat(data.list);
					this.officeList = data.list;
					if(data.list && data.list.length == 0) this.isNoData = true;
					else  this.isNoData = false;
					this.isShowPage = true;
				});
			},
			getTeamPage(){
				if (!this.isTeamLoad) return false;
				this.isTeamLoad = false;
				let form = this.teamForm;
				if(this.searchText) form.title = this.searchText;
				else delete form.title;
				req.getRequest(api.user_team_page,form,data=>{
					if (data.list && data.list.length >= 10) this.isTeamLoad = true;
					if (this.teamForm.page > 1) data.list = this.teamList.concat(data.list);
					this.teamList = data.list;
					if(data.list && data.list.length == 0) this.isNoData = true;
					else  this.isNoData = false;
				})
			},
			//提交点赞、取消点赞；收藏、取消收藏
			submitFabulous(type, id, index) {
				if (!req.isLogins(true)) {
					return;
				}
				var dataP = {};
				dataP.type = type; //1，观看 ，2点赞，3评论，4分享，5收藏
				dataP.momentsId = id;
				req.postRequestLoding('/api/v3/fabulous/save', dataP, data => {
					if (type == 2) {
						//动态点赞
						if (this.officeList[index].isPraise == 1) {
							//已赞
							this.officeList[index].isPraise = 0;
							this.officeList[index].count.fabulousCount--;
						} else {
							this.officeList[index].isPraise = 1;
							this.officeList[index].count.fabulousCount++;
						}
					}
				});
			},
	
			//提交投票
			submitPoll(item, pIndex, pollIndex) {
				if(item.qyPoll.isEnd){
					this.jumpUrlDetail(item)
					return false;
				} 
				var dataP = {};
				// dataP.id = item.id;
				dataP.pollId = item.qyPoll.id;
				var pollObjList = JSON.parse(item.qyPoll.optionJson);
				dataP.pollOptionCode = pollObjList[pollIndex].code;
				req.postRequest('/api/v3/poll/saveDetails', dataP, data => {
					req.msg('投票成功');
					//图片完之后要将该投票的对象返回，便于做渲染%
					this.officeList[pIndex].qyPoll = data;
				});
			},
			goTop: function(e) {
				// 一键回到顶部
				if (uni.pageScrollTo) {
					uni.pageScrollTo({
						scrollTop: 0
					});
				} else {
					uni.showModal({
						title: '提示',
						content: '当前微信版本过低，无法使用该功能，请升级到最新微信版本后重试。'
					});
				}
			},
			videoPlay(index){
			    var that = this;
			    var curIdx = index;
			    this.officeList[index].isControls = true
			    this.officeList[index].isShowPlayBtn = false
			    // 有播放时先将prev暂停，再播放当前点击的current
			    if (that.videoCurrent != null) {
					var videoContextPrev = uni.createVideoContext('myVideo' + that.videoCurrent)
					if (that.videoCurrent != curIdx) {
						this.officeList[that.videoCurrent].isControls = false
						this.officeList[that.videoCurrent].isShowPlayBtn = true
						
						videoContextPrev.stop()
					}
					that.videoCurrent = curIdx
					var videoContextCurrent = uni.createVideoContext('myVideo' + curIdx)
					videoContextCurrent.play()
			    } else {  
					// 没有播放时播放视频
					that.videoCurrent = curIdx
					var videoContext = uni.createVideoContext('myVideo' + curIdx) // 对应的视频id
					videoContext.play()
			    }
			},
			videoPause(index){
				this.officeList[index].isControls = false
				this.officeList[index].isShowPlayBtn = true
			},
			videoEnded(index){
				this.officeList[index].isControls = false
				this.officeList[index].isShowPlayBtn = true
			},
			joinTeam(item,index){
				if(item.isJoin == 1) {
					uni.navigateTo({
						url: '/office/team/index?id='+item.id
					})
					return false;
				}
				req.postRequest(api.user_team_follow,{userGroupId: item.id},data=>{
					req.msg('加入团队成功');
					setTimeout(res=>{
						this.jumpUrl('/office/team/index?id='+item.id);
					},200)
				})
			}
		},
		created() {
			const systemInfo = uni.getSystemInfoSync();
			// px转换到rpx的比例
			let pxToRpxScale = 750 / systemInfo.windowWidth;
			let systems = {
				ktxStatusHeight: systemInfo.statusBarHeight * pxToRpxScale, // 状态栏的高度
				navigationHeight: 44 * pxToRpxScale // 导航栏的高度
			};
			systems.barHeight = systems.ktxStatusHeight + systems.navigationHeight;
			this.systems = systems;
		},
		onShareAppMessage: function() {
			let path = '/pages/interactive/index?isShare=' + true;
			if (req.getStorage('userInfo')) {
				path += '&userId=' + req.getStorage('userInfo').id;
			}
			if (req.getStorage('MERCHANT') && req.getStorage('MERCHANT').id != null) {
				path += '&merchantId=' + req.getStorage('MERCHANT').id;
		
				if (req.getStorage('smallShop') && req.getStorage('MERCHANT').id != null) {
					path += '&shopId=' + req.getStorage('smallShop').id;
				}
			}
			let title = '';
			if (this.merchant && this.merchant.title && this.merchant.title != '默认门店') {
				title = this.merchant.title;
			} else {
				title = this.config.CONFIG_PROJECT_TITLE;
			}
			return {
				title: (req.excludeSpecial(req.getStorage('userInfo').nickName) ? req.excludeSpecial(req.getStorage('userInfo').nickName) : '') + '为你推荐' + title,
				path: path
			};
		},
		onShareTimeline() {
			let path = 'isShare=' + true;
			if (req.getStorage('userInfo')) {
				path += '&userId=' + req.getStorage('userInfo').id;
			}
			if (req.getStorage('MERCHANT') && req.getStorage('MERCHANT').id != null) {
				path += '&merchantId=' + req.getStorage('MERCHANT').id;
		
				if (req.getStorage('smallShop') && req.getStorage('MERCHANT').id != null) {
					path += '&shopId=' + req.getStorage('smallShop').id;
				}
			}
			let title = '';
			if (this.merchant && this.merchant.title && this.merchant.title != '默认门店') {
				title = this.merchant.title;
			} else {
				title = this.config.CONFIG_PROJECT_TITLE;
			}
			return {
				title: (req.excludeSpecial(req.getStorage('userInfo').nickName) ? req.excludeSpecial(req.getStorage('userInfo').nickName) : '') + '为你推荐' + title,
				query: path
			};
		}
	}
</script>

<style>
	@import "./index.css";
</style>
